#include <iostream>
#include <algorithm>
#include <vector>
#include <limits>

using namespace std;

double inf = numeric_limits<double>::max();

struct Cheetah{
  int t, v, b;
  bool operator<(const Cheetah & c)const{
    return t < c.t;
  }
};

struct Inter{
  double x1, y1, x2, a, b;
  int ind;
};


vector<Inter> fastest, slowest;
vector<Cheetah> input;

void testIntersect(Cheetah & c, Inter & inter, bool &intersect, bool &left, double &x, double&y){
  x = (c.b - inter.b)/(inter.a - c.v);
  y = inter.a*x + inter.b;
  intersect = (x > inter.x1 && x < inter.x2);
  left = (x < inter.x1);
}

/*j
void search2(int beg, int end, int cInd){
  Cheetah &c = input[cInd];
  if(end - beg <= 1) cerr << "ERROR" << '\n';
  int s = (beg+end)/2;
  bool intersect, left;
  double x, y;
  if(fastest[s].a == c.v) return;
  testIntersect(c, fastest[s], intersect, left, x, y);
  if(intersect){
    fastest[s].x2 = x;
    fastest.resize(s+1);
    fastest.push_back(Inter{x, y, inf, inter.v, -c.v*c.t, cInd});
  } else if(left){
    search(beg, s, c);
  } else{
    search(s+1, end, c);
  }
}
*/

/*
void search(int beg, int end, int cInd){
  Cheetah &c = input[cInd];
  if(end - beg <= 1) cerr << "ERROR" << '\n';
  int s = (beg+end)/2;
  bool intersect, left;
  double x, y;
  if(fastest[s].a == c.v) return;
  testIntersect(c, fastest[s], intersect, left, x, y);
  if(intersect){
    fastest[s].x2 = x;
    fastest.resize(s+1);
    fastest.push_back(Inter{x, y, inf, fastest[s].a, -c.v*c.t, cInd});
  } else if(left){
    search(beg, s, cInd);
  } else{
    search(s+1, end, cInd);
  }
}
*/

void search(int beg, int end, int cInd){
  Cheetah &c = input[cInd];
  if(end - beg <= 1){
    cerr << "ERROR" << '\n';
    return;
  }
  cerr << "search" << '\n';
  int s = (beg+end)/2;
  bool intersect, left;
  double x, y;
  if(fastest[s].a == c.v) return;
  testIntersect(c, fastest[s], intersect, left, x, y);
  if(intersect){
    fastest[s].x2 = x;
    fastest.resize(s+1);
    fastest.push_back(Inter{x, y, inf, fastest[s].a, -c.v*c.t, cInd});
  } else if(left){
    search(beg, s, cInd);
  } else{
    search(s+1, end, cInd);
  }
}

int main(){
  while(true){
    cout << "new testcase ------------------ " << '\n';
    int N;
    cin >> N;
    if(N == 0) return 0;
    input = vector<Cheetah>(N);
    for(int i=0; i<N; ++i){
      cin >> input[i].t >> input[i].v;
      input[i].b = -input[i].t*input[i].v;
    }
    sort(input.begin(), input.end());
    fastest.resize(0);
    slowest.resize(0);
    fastest.push_back(Inter{input[0].t, 0, inf, input[0].v, input[0].b, 0});
    slowest.push_back(Inter{input[N-1].t, 0, inf, input[N-1].v, input[N-1].b, N-1});
    for(int i=1; i<N; ++i){
      search(0, fastest.size(), i);
    }
    for(int i=0; i<(int)fastest.size(); ++i){
      cout << "(" << fastest[i].x1 << ", " << fastest[i].x2 << "), ";
    }
    cout << '\n';
  }
  return 0;
}
